/***************
 Subaquatic 128K
 ***************/

#include <spritepack.h>
#include "graficos.h"
#include "objetos.h"
#include "mapa.h"
#include "aplib.h"

#pragma output STACKPTR=24999

//constantes

#define LIM_ARRIBA 1
#define LIM_ABAJO  19
#define ANCHOTILE 2
#define ALTOTILE 2
#define N_OBJETOS 12
#define N_ENEMIGOS 70
#define ENE_PANTALLA 2

#define INICIAEFECTO	0xC364
#define WYZPLAYERISR	0xC021	// Esto es INICIO en el cdigo de wyzplayer.asm
#define CARGA_CANCION	0xC05E
#define SILENCIA_PLAYER 0xC043
#define	CANAL_FX		1		// Canal por el que suenan los efectos de sonido

unsigned char lenguaje = 0; 	// 0 = ingls, 1 = espaol
unsigned char is128k;
extern unsigned int asm_int[1];
unsigned char play;
struct sp_Rect spritesClipValues;
struct sp_Rect *spritesClip;
extern struct sp_Rect *sp_ClipStruct;
void *joyfunc;					// Puntero a la funcin de manejo seleccionada.

#asm
	LIB SPCClipStruct
._sp_ClipStruct 		
	defw SPCClipStruct
#endasm

// Structs:

struct sp_UDK keys;

typedef struct {
	unsigned char *current_frame, *next_frame;
	char *frames [4];
} GRAF_ENE;

typedef struct {
	unsigned char dx,dy;
	unsigned char *current_frame, *next_frame;
	unsigned char frame, subframe, facing;
	char oxigeno;
	unsigned char botellas;
	unsigned char direccion;
} MUNECO;

typedef struct {
	unsigned char x,y;
	unsigned char movimiento;	// vertical u horizontal, 1 horizontal, 2 vertical
	unsigned char velocidad;
	unsigned char pantalla;
	unsigned char tipo; 		// 1, pez, 2 pulpo.....
	unsigned char tocado;
	unsigned char contador;
} ENEMIGO;

typedef struct {
	unsigned char pantalla; 	// pantalla en el que se encuentra
	unsigned char x, y; 		// posicion
	unsigned char status;		// estado del objeto
	unsigned char tipo; 		// grafico
	unsigned char fondo;		// grafico del fondo a poner
} OBJETO;

typedef struct {
	unsigned char *current_frame, *next_frame;
	unsigned char facing;
} FRAMES;

typedef struct {
	unsigned char posicion;
	unsigned char tile;
} MAPA_MODIFICADO;

// Textos en espaol e ingls.
// texto = 9 * 14 * language + txtidx * 14 = 14 * (9 * language + txtidx)

unsigned char led_textos [] = {
	
	// INGLS
	
	// men_cogido ()
	180, 180, 180, 180, 180, 180, 195, 182, 190, 185, 183, 191, 180, 180,
	180, 180, 180, 180, 180, 200, 181, 197, 185, 194, 180, 180, 180, 180,
	
	// pergamino_cogido ()
	180, 180, 180, 187, 195, 191, 180, 191, 207, 185, 180, 180, 180, 180,
	180, 180, 180, 180, 199, 183, 198, 195, 192, 192, 180, 180, 180, 180,
	
	// mascara_cogido ()
	180, 180, 180, 187, 195, 191, 180, 191, 207, 185, 180, 180, 180, 180,
	180, 180, 180, 180, 180, 180, 193, 181, 199, 197, 180, 180, 180, 180,
	
	// diamante cogido ()
	180, 180, 180, 187, 195, 191, 180, 191, 207, 185, 180, 180, 180, 180,
	180, 180, 180, 184, 189, 181, 193, 195, 194, 184, 180, 180, 180, 180,
	
	// flor_cogido ()
	180, 180, 180, 187, 195, 191, 180, 191, 207, 185, 180, 180, 180, 180,
	180, 180, 180, 180, 186, 192, 195, 203, 185, 198, 180, 180, 180, 180,
	
	// oxigeno_cogido ()
	180, 180, 180, 195, 204, 205, 187, 185, 194, 180, 180, 180, 180, 180, 
	180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180,
	
	// compuerta_abierta ()
	180, 180, 180, 187, 181, 191, 185, 180, 195, 196, 185, 194, 180, 180,
	180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180,
	
	// peligro ()
	180, 180, 180, 180, 184, 181, 194, 187, 185, 198, 180, 180, 180, 180,
	180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180,
	
	// comienza_aventura ()
	191, 207, 185, 180, 181, 202, 185, 194, 191, 201, 198, 185, 180, 180,
	180, 180, 180, 180, 180, 182, 185, 187, 189, 194, 199, 180, 180, 180,
	
	// APA
	
	// men_cogido ()
	180, 180, 180, 180, 180, 180, 195, 182, 190, 185, 191, 195, 180, 180, 
	180, 180, 180, 180, 198, 185, 183, 195, 187, 189, 184, 195, 180, 180, 

	// pergamino_cogido ()
	191, 189, 185, 194, 185, 199, 180, 180, 185, 192, 180, 180, 180, 180,
	180, 180, 196, 185, 198, 187, 181, 193, 189, 194, 195, 180, 180, 180,
	
	// mascara_cogido ()
	180, 180, 191, 189, 185, 194, 185, 199, 180, 192, 181, 180, 180, 180,
	180, 180, 180, 193, 181, 199, 183, 181, 198, 181, 180, 180, 180, 180,

	// diamante cogido ()
	180, 180, 191, 189, 185, 194, 185, 199, 180, 185, 192, 180, 180, 180,
	180, 180, 184, 189, 181, 193, 181, 194, 191, 185, 180, 180, 180, 180,
	
	// flor_cogido ()
	180, 180, 191, 189, 185, 194, 185, 199, 180, 192, 181, 180, 180, 180,
	180, 180, 180, 180, 186, 192, 195, 198, 180, 180, 180, 180, 180, 180,
	
	// oxigeno_cogido ()
	180, 180, 195, 204, 189, 187, 185, 194, 195, 180, 180, 180, 180, 180,
	180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 
	
	// compuerta_abierta ()
	180, 183, 195, 193, 196, 201, 185, 198, 191, 181, 180, 180, 180, 180,
	180, 180, 181, 182, 189, 185, 198, 191, 181, 180, 180, 180, 180, 180,
	
	// peligro ()
	180, 180, 180, 196, 185, 192, 189, 187, 198, 195, 180, 180, 180, 180,
	180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180, 180,
	
	// comienza_aventura ()
	180, 183, 195, 193, 189, 185, 194, 188, 181, 180, 192, 181, 180, 180,
	180, 180, 181, 202, 185, 194, 191, 201, 198, 181, 180, 180, 180, 180
};

#asm
defw 0						  /* two free bytes before start of a hook */
#endasm

void ISR(void) {
	#asm
		;ld a, r
		;out (254),a
		ld b, 1
		call SetRAMBank
		call WYZPLAYERISR
		ld b, 0
		call SetRAMBank 		
	#endasm
}

void SetRAMBank() {
#asm
	.SetRAMBank
	
	ld	A, ($5B5C)
	and F8h
	or	B
	ld	BC, $7FFD
	ld	($5B5C), A
	out (C), A
	
#endasm
}

void unpack_RAM3 (unsigned int address) {
	asm_int [0] = address;
	
	#asm	
		di
		ld b, 3
		call SetRAMBank
		
		ld hl, (_asm_int)
		ld de, 16384
		call depack
		
		ld b, 0
		call SetRAMBank
		ei
	#endasm
}

void pinta_supertile (unsigned char x, unsigned char y, unsigned char i) {
	unsigned char idx = i << 3;

	sp_PrintAtInv (y, x, supertiles[idx+4], supertiles[idx]);
	sp_PrintAtInv (y, x+1, supertiles[idx+5], supertiles[idx+1]);
	sp_PrintAtInv (y+1, x, supertiles[idx+6], supertiles[idx+2]);
	sp_PrintAtInv (y+1, x+1, supertiles[idx+7], supertiles[idx+3]);
}

void pinta_objetos (unsigned char x, unsigned char y, unsigned char i) {
	unsigned char idx = i << 3;

	sp_PrintAtInv (y, x, superobjetos[idx+4], superobjetos[idx]);
	sp_PrintAtInv (y, x+1, superobjetos[idx+5], superobjetos[idx+1]);
	sp_PrintAtInv (y+1, x, superobjetos[idx+6], superobjetos[idx+2]);
	sp_PrintAtInv (y+1, x+1, superobjetos[idx+7], superobjetos[idx+3]);
}

void pinta_led (unsigned char msg_id) {
	
	// jL :: Voy a sustituir las funciones (y sus llamadas)
	
	// men_cogido			0, 
	// pergamino_cogido 	1, 
	// mascara_cogido		2,
	// diamante_cogido		3,
	// flor_cogido			4,
	// oxigeno_cogido		5,
	// compuerta_abierta	6,
	// peligro				7,
	// comienza aventura	8,
	
	
	unsigned int idx;
	unsigned char x, y;
	unsigned char i;
	
	idx = (9 * lenguaje + msg_id) * 28;
	
	x = 17; y = 21;
	
	for (i = 0; i < 28; i ++) {
		sp_PrintAtInv (y, x, (led_textos [idx] == 180) ? 4 : 68, led_textos [idx]);
		idx ++;
		x ++;
		if (x == 31) {
			x = 17;
			y ++;
		}
	}
}

void cortina () {
	#asm
		;; Antes que nada vamos a limpiar el PAPER de toda la pantalla
		;; para que no queden artefactos feos
		
		ld	de, 22528			; Apuntamos con DE a la zona de atributos
		ld	b,	3				; Procesamos 3 tercios
	.clearb1
		push bc
		
		ld	b, 255				; Procesamos los 256 atributos de cada tercio
	.clearb2
	
		ld	a, (de)				; Nos traemos un atributo
		and	199					; Le hacemos la mscara 11000111 y dejamos PAPER a 0
		ld	(de), a				; Y lo volvemos a poner
		
		inc de					; Siguiente atributo
	
		djnz clearb2
		
		pop bc
		djnz clearb1
		
		;; Y ahora el cdigo original que escrib para UWOL:	
	
		ld	a,	8
	
	.repitatodo
		ld	c,	a			; Salvamos el contador de "repitatodo" en 'c'
	
		ld	hl, 16384
		ld	a,	12
	
	.bucle
		ld	b,	a			; Salvamos el contador de "bucle" en 'b'
		ld	a,	255
	
	.bucle1
		sla (hl)
		inc hl
		dec a
		jr	nz, bucle1
			
		ld	a,	255
	.bucle2
		srl (hl)
		inc hl
		dec a
		jr	nz, bucle2
			
		ld	a,	b			; Restituimos el contador de "bucle" a 'a'
		dec a
		jr	nz, bucle
	
		ld	a,	c			; Restituimos el contador de "repitatodo" a 'a'
		dec a
		jr	nz, repitatodo
	#endasm
	// Estoy llorando 
}

void game_over() {
	sp_PrintAtInv (21, 20, 68, 187);
	sp_PrintAtInv (21, 21, 68, 181);
	sp_PrintAtInv (21, 22, 68, 193);
	sp_PrintAtInv (21, 23, 68, 185);

	sp_PrintAtInv (22, 20, 68, 195);
	sp_PrintAtInv (22, 21, 68, 202);
	sp_PrintAtInv (22, 22, 68, 185);
	sp_PrintAtInv (22, 23, 68, 198);
}
	
// Variables globales:

MAPA_MODIFICADO mapa_mod[10] = { 
	{2998,27},
	{3524,16},
	{4049,27},
	{2988,16},
	{3165,10},
	{3166,10},
	{3167,10},
	{3168,10},
	{3169,10},
	{4039,16}
};

ENEMIGO enemigos[N_ENEMIGOS] = { 
	{ 40, 64,  1,  1,  0,  1,  0,  0},	{104, 96,  1,  1,  0,  3,  0,  0},
	{ 40, 32,  1,  1,  1,  2,  0,  0},	{184, 80,  1,  1,  1,  3,  0,  0},
	{ 88,112,  1,  1,  2,  1,  0,  0},	{ 72, 64,  1,  1,  2,  3,  0,  0},
	{ 56,112,  1,  1,  3,  1,  0,  0},	{184, 32,  1,  1,  3,  2,  0,  0},
	{ 72, 48,  1,  1,  4,  2,  0,  0},	{200, 64,  1,  1,  4,  3,  0,  0},
	{184, 80,  1,  1,  5,  3,  0,  0},	{120,112,  1,  1,  5,  2,  0,  0},
	{104, 64,  1,  1,  6,  1,  0,  0},	{152,112,  1,  1,  6,  3,  0,  0},
	{ 56, 32,  1,  1,  7,  2,  0,  0},	{120, 96,  1,  1,  7,  1,  0,  0},
	{120, 96,  1,  1,  8,  3,  0,  0},	{200, 32,  1,  1,  8,  2,  0,  0},
	{ 56, 80,  1,  1,  9,  3,  0,  0},	{120,144,  1,  1,  9,  1,  0,  0},
	{104,112,  1,  1, 10,  1,  0,  0},	{ 56, 32,  1,  1, 10,  2,  0,  0},
	{ 56, 32,  1,  1, 11,  2,  0,  0},	{136, 64,  1,  1, 11,  3,  0,  0},
	{152,112,  1,  1, 12,  3,  0,  0},	{ 40, 48,  1,  1, 12,  1,  0,  0},
	{120, 32,  1,  1, 13,  1,  0,  0},	{136, 48,  1,  1, 13,  3,  0,  0},
	{ 88, 48,  1,  1, 14,  2,  0,  0},	{152, 80,  1,  1, 14,  3,  0,  0},
	{200, 32,  1,  1, 15,  2,  0,  0},	{ 48, 40,  1,  1, 15,  3,  0,  0},
	{ 40, 64,  1,  1, 16,  1,  0,  0},	{136,112,  1,  1, 16,  3,  0,  0},
	{104,112,  1,  1, 17,  3,  0,  0},	{ 72, 64,  1,  1, 17,  1,  0,  0},
	{ 56,112,  1,  1, 18,  1,  0,  0},	{ 56, 48,  1,  1, 18,  2,  0,  0},
	{ 72, 48,  1,  1, 19,  1,  0,  0},	{168, 96,  1,  1, 19,  3,  0,  0},
	{ 56, 80,  1,  1, 20,  1,  0,  0},	{100,132,  1,  1, 20,  3,  0,  0},
	{ 72, 80,  1,  1, 21,  1,  0,  0},	{200, 48,  1,  1, 21,  2,  0,  0},
	{ 40, 80,  1,  1, 22,  2,  0,  0},	{168, 32,  1,  1, 22,  1,  0,  0},
	{136, 96,  1,  1, 23,  3,  0,  0},	{120,112,  1,  1, 23,  2,  0,  0},
	{ 88, 48,  1,  1, 24,  2,  0,  0},	{136,128,  1,  1, 24,  1,  0,  0},
	{ 88, 96,  1,  1, 25,  3,  0,  0},	{136, 64,  1,  1, 25,  2,  0,  0},
	{104,128,  1,  1, 26,  3,  0,  0},	{136, 64,  1,  1, 26,  1,  0,  0},
	{ 56,128,  1,  1, 27,  1,  0,  0},	{ 88,112,  1,  1, 27,  3,  0,  0},
	{152, 96,  1,  1, 28,  1,  0,  0},	{ 72, 96,  1,  1, 28,  3,  0,  0},
	{ 56, 80,  1,  1, 29,  3,  0,  0},	{184, 48,  1,  1, 29,  2,  0,  0},
	{ 56,112,  1,  1, 30,  1,  0,  0},	{ 88, 80,  1,  1, 30,  3,  0,  0},
	{ 56,112,  1,  1, 31,  1,  0,  0},	{ 72, 64,  1,  1, 31,  3,  0,  0},
	{ 72, 64,  1,  1, 32,  3,  0,  0},	{184, 80,  1,  1, 32,  1,  0,  0},
	{168,112,  1,  1, 33,  2,  0,  0},	{136, 48,  1,  1, 33,  3,  0,  0},
	{ 56, 48,  1,  1, 34,  2,  0,  0},	{136, 32,  1,  1, 34,  3,  0,  0}
};

OBJETO objetos[N_OBJETOS] = {	
//	  p    x  y   st  ti  fondo
	{  1,  5, 14,  0, 13,  1},			// oxgeno
	{ 21,  9,  4,  0, 13,  1},			// oxgeno
	{ 25,  5, 10,  0, 13,  1},			// oxgeno
	{ 13,  9,  6,  0, 13,  1},			// oxgeno
	{ 16, 11, 12,  0, 13,  1},			// oxgeno
	{  5, 21,  6,  0, 13,  1},			// oxgeno
	{ 11, 15, 10,  0, 13,  1},			// oxgeno
	{  0,  5,  6,  0, 13,  1},			// oxgeno
	{ 31, 19,  4,  0,  1,  1},			// diamante
	{ 28, 21, 14,  0,  2,  1}, 			// mascara
	{  6, 15,  4,  0,  3,  1},			// pergamino
	{ 17, 21, 16,  0,  4,  1}			// flol
};

MUNECO mun;
FRAMES tabla_frames[3];
struct sp_SS *spritesEne[ENE_PANTALLA], *spriteArpon;
struct sp_SS *spriteBuzo;
unsigned int numero_pantalla = 25;
unsigned char tabla_posiciones[2];
unsigned char tabla_pos_enemigos[ENE_PANTALLA]; // esta tabla guarda la posicion de los enemigos en pantalla en la tabla general de enemigos
unsigned char disparado = 0;
unsigned char posicion_disparo_x;
unsigned char posicion_disparo_y;
unsigned char direccion_disparo = 0;
unsigned char cambia_pantalla = 0;
unsigned char numero_arpones = 5;
unsigned char objeto_cogido = 0;				// solo podemos llevar un objeto!
unsigned char contador_vida = 0;
unsigned char contador_patas = 0;
unsigned char interruptores = 0;				// numero de interruptores activados
unsigned char objeto_soltado = 0;
unsigned char objeto_pergamino = 0;
unsigned char objeto_diamante = 0;
unsigned char objeto_mascara = 0;
unsigned char objeto_flor = 0;
char bandera_disparo = 0;
extern char asm_number[1];
extern unsigned int asm_int_2 [1];
extern unsigned int seed [1];

#asm
._asm_number 
	defb 0
._asm_int
	defw 0
._asm_int_2
	defw 0
._seed	
	defw 0
#endasm

// Funciones:

/* MusicISR */

void srand (unsigned int new_seed) {
	seed [0] = new_seed;	
}

unsigned char rand () {
	unsigned char res;
	
	#asm
		.rand16
			ld	hl, _seed
			ld	a, (hl)
			ld	e, a
			inc	hl
			ld	a, (hl)
			ld	d, a
			
			;; Ahora DE = [SEED]
						
			ld	a,	d
			ld	h,	e
			ld	l,	253
			or	a
			sbc	hl,	de
			sbc	a, 	0
			sbc	hl,	de
			ld	d, 	0
			sbc	a, 	d
			ld	e,	a
			sbc	hl,	de
			jr	nc,	nextrand
			inc	hl
		.nextrand
			ld	d,	h
			ld	e,	l
			ld	hl, _seed
			ld	a,	e
			ld	(hl), a
			inc	hl
			ld	a,	d
			ld	(hl), a
			
			;; Ahora [SEED] = HL
		
			ld 	hl, _asm_int
			ld	a,	e	
			ld	(hl), a
			inc	hl
			ld	a,	d
			ld	(hl), a
			
			;; Ahora [ASM_INT] = HL
	#endasm
	
	res = asm_int [0];

	return res;
}

void wyz_play_sound (unsigned char fx_number, unsigned char fx_channel) {
	asm_int_2 [0] = fx_channel + (fx_number * 256);
	
	#asm
		di
		ld b,1
		call SetRAMBank
		ld bc, (_asm_int_2)
		call INICIAEFECTO
		ld b,0
		call SetRAMBank
		ei
	#endasm
}

void wyz_play_music (unsigned char song_number) {
	asm_int_2 [0] = song_number;

	#asm
		di
		ld b, 1
		call SetRAMBank
		ld a, (_asm_int_2)
		call CARGA_CANCION
		ld b, 0
		call SetRAMBank
		ei
	#endasm
}

void wyz_stop_sound ()
{
	#asm
		di
		ld b,1
		call SetRAMBank
		call SILENCIA_PLAYER
		ld b,0
		call SetRAMBank
		ei
	#endasm
}

unsigned char my_attr (unsigned char x, unsigned char y) {
	unsigned char *res;
	
	res = (unsigned char *) (22528 + x + (y << 5));
	
	return (*res);
}

void disparar() {
	unsigned char xx,yy;

	xx = mun.dx>>3;
	yy = mun.dy>>3;

	if (mun.direccion == 0 ) {									// dispara a la derecha
		if (my_attr(xx+2,yy) < 6 && my_attr(xx+2,yy+1)<6 ) {	// no hay nada o un enemigo
			posicion_disparo_x = mun.dx+15;
			posicion_disparo_y = mun.dy +2;
			disparado = 1;
			direccion_disparo = 1;								// derecha
		}
	} else {
		if (my_attr(xx-1,yy) < 6 && my_attr(xx-1,yy+1)<6 ) {	// no hay nada o un enemigo
			posicion_disparo_x = mun.dx-2;
			posicion_disparo_y = mun.dy +2;
			disparado = 1;
			direccion_disparo = 2;								// izquierda
		}
	}
}

unsigned char borra_disp = 0;

void mueve_disparo() {
	unsigned char xx,yy;

	xx = posicion_disparo_x>>3;
	yy = posicion_disparo_y>>3;
	if (disparado != 0) {										// aqui movemos el disparo
		if (direccion_disparo == 1) {							// vamos a la derecha
			if (my_attr(xx+1,yy)>=6 || my_attr(xx+1,yy+1)>=6 ||my_attr(xx+1,yy+1)>=6 || posicion_disparo_x > 210 || cambia_pantalla == 1) { //destruimos el disparo
				disparado = 0;
				sp_MoveSprAbs(spriteArpon, sp_ClipStruct, 0, -10, -10, -10, -10);
				direccion_disparo = 0;
				bandera_disparo = 0;

				borra_disp = 1;
				cambia_pantalla = 0;
				posicion_disparo_x = -1;
				posicion_disparo_y = -1;
			} else {
				posicion_disparo_x=posicion_disparo_x+4;
			}
		}
		if (direccion_disparo == 2) {							// vamos a la izquierda

			if (my_attr(xx-1,yy)>=6 || my_attr(xx-1,yy+1)>=6 ||my_attr(xx-1,yy+1)>=6 || posicion_disparo_x < 28 || cambia_pantalla == 1) { //destruimos el disparo
				disparado = 0;
				sp_MoveSprAbs(spriteArpon, sp_ClipStruct, 0, -10, -10, -10, -10);
				direccion_disparo = 0;
				bandera_disparo = 0;
				borra_disp = 1;
				cambia_pantalla = 0;
				posicion_disparo_x = -1;
				posicion_disparo_y = -1;
			} else {
				posicion_disparo_x=posicion_disparo_x-4;
			}
		}

		// movemos
		if (borra_disp != 1) {
			sp_MoveSprAbs(spriteArpon, sp_ClipStruct, 0, posicion_disparo_y>>3, posicion_disparo_x>>3, posicion_disparo_x &7, posicion_disparo_y&7);
		} else {
			borra_disp = 0;
		}
	} else {
		bandera_disparo = 0;
	}
}

void *my_malloc(unsigned int bytes) {
	return sp_BlockAlloc(0);
}

void *u_malloc = my_malloc;
void *u_free = sp_FreeBlock;

unsigned char cambia_cara = 0;

void limpia_led() {
	int i,j ;
	for (i = 16; i < 31; i++) {
		for (j = 21; j <23; j++) {
			sp_PrintAtInv (j, i, 4, 180);
		}

	}
}

void elimina_enemigos_pantalla() {
	unsigned char i;
	for (i = 0; i < 3; i++) {
		sp_MoveSprAbs(spritesEne[i], sp_ClipStruct, 0, -10, -10, -10, -10);
		if ((i == 0) || (i==1)) {
			tabla_posiciones[i] = -1;
		}
	}

}

unsigned char objeto_cargado = 0;								// objetos que estan en el barco

// Rutina carga de pantalla

void pinta_pantalla() {
	unsigned char x,y;
	unsigned char contador;
	unsigned int i = 0;

	y= 2;														// antes, 117 en el bucle, 845
	contador = 0;
	x= 3;
	for (i = (117*numero_pantalla); i < 117 + (117*numero_pantalla) ; i++) {

		contador++;
		pinta_supertile(x,y,pantalla[i]);
		x = x + ANCHOTILE;

		if (contador == 13) {
			y = y+ALTOTILE;
			x=3;
			contador = 0;
		}
	}

	// pintamos los objetos del juego
	
	for (i = 0; i < N_OBJETOS ; i++) {
		if (numero_pantalla == objetos[i].pantalla) {			// es la pantalla donde estamos
			if (objetos[i].status == 0) {
				pinta_objetos(objetos[i].x,objetos[i].y,objetos[i].tipo);
			}
		}
	}
}

void draw_vida () {
	sp_PrintAtInv (21,1, 112, 60 + mun.oxigeno / 100);
	sp_PrintAtInv (21, 2, 112, 60 + (mun.oxigeno % 100) / 10);
	sp_PrintAtInv (21, 3, 112, 60 + mun.oxigeno % 10);
}

void parada() {
	unsigned char i,j;
	for (i = 0; i < 250 ; i++) {
		for (j=0; j<30;j++) {
		}
	}
}

unsigned char puede_pintar = 0;
unsigned char pinta = 1;

void mini_parada() {
	unsigned char i;
	for (i = 0; i < 250 ; i++) {
	}
}

void pinta_arpones(unsigned char num) {
	unsigned char pos = 60;

	pos = 60 + num;
	sp_PrintAtInv (22, 11, 112, pos);
}

// Funcion para la carga de enemigos de cada pantalla

void carga_enemigos() {
	unsigned char i;

	unsigned char posicion;

	unsigned char numero_en_pantalla = 2;	
	posicion = 0;


	for (i = 0; i < N_ENEMIGOS && numero_en_pantalla > 0 ; i++) {

		if (enemigos[i].pantalla == numero_pantalla) {
			// lo cargamos y pintamos en pantalla
			
			numero_en_pantalla--;
			
			// guardamos la posicion de la tabla principal
			
			tabla_posiciones[posicion] = i;   
			posicion++;
		}
	}
}

void animacion_1() {
	unsigned char savePantalla;
	unsigned char pitimini;
	unsigned int map_idx;
	
	sp_MoveSprAbs(spriteBuzo, sp_ClipStruct, 0, -10, -10, -10, -10);
	mun.next_frame = buzo_r_a_1;

	elimina_enemigos_pantalla();
	savePantalla = numero_pantalla;
	numero_pantalla = 25;
	pinta_pantalla();
	sp_UpdateNow();
	
	// Animacion
	
	map_idx = 2970;
	for (pitimini = 0; pitimini < 5; pitimini ++) {
		mini_parada();
		pantalla[map_idx] = 0; 
		map_idx += 13;
		pinta_pantalla();
		sp_UpdateNow();
	}
	
	parada();
	numero_pantalla = savePantalla;
	pinta_pantalla();
	sp_UpdateNow();
	carga_enemigos();
	mun.next_frame = mun.current_frame;
	
	sp_MoveSprAbs(spriteBuzo, sp_ClipStruct, mun.next_frame - mun.current_frame, mun.dy >> 3, mun.dx >> 3, mun.dx & 7, mun.dy &7);
}

void animacion_2() {
	unsigned char savePantalla,i,j;
	unsigned char pitimini;
	unsigned int map_idx;
	sp_MoveSprAbs(spriteBuzo, sp_ClipStruct, 0, -10, -10, -10, -10);
	mun.next_frame = buzo_r_a_1;

	elimina_enemigos_pantalla();
	savePantalla = numero_pantalla;
	numero_pantalla = 26;
	pinta_pantalla();
	sp_UpdateNow();
	
	// Animacion
	
	map_idx = 3071;
	for (pitimini = 0; pitimini < 7; pitimini ++) {
		mini_parada();
		pantalla[map_idx] = 0;
		map_idx ++;
		pinta_pantalla();
		sp_UpdateNow();
	}
	
	parada();
	numero_pantalla = savePantalla;
	pinta_pantalla();
	sp_UpdateNow();
	carga_enemigos();
	mun.next_frame = mun.current_frame;
	
	sp_MoveSprAbs(spriteBuzo, sp_ClipStruct, mun.next_frame - mun.current_frame, mun.dy >> 3, mun.dx >> 3, mun.dx & 7, mun.dy &7);
}

void animacion_3() {
	unsigned char savePantalla,i,j;
	sp_MoveSprAbs(spriteBuzo, sp_ClipStruct, 0, -10, -10, -10, -10);
	mun.next_frame = buzo_r_a_1;

	elimina_enemigos_pantalla();
	savePantalla = numero_pantalla;
	numero_pantalla = 13;
	pinta_pantalla();
	sp_UpdateNow();
	
	// Animacion
	
	parada();
	pantalla[1578] = 0;
	mini_parada();
	pinta_pantalla();
	sp_UpdateNow();

	numero_pantalla = savePantalla;
	pinta_pantalla();
	sp_UpdateNow();
	carga_enemigos();
	mun.next_frame = mun.current_frame;
	
	sp_MoveSprAbs(spriteBuzo, sp_ClipStruct, mun.next_frame - mun.current_frame, mun.dy >> 3, mun.dx >> 3, mun.dx & 7, mun.dy &7);
}

void mueve() {
	unsigned char xx, yy;
	unsigned char x, y;
	int dx, dy;
	unsigned char i;
	char nosmovemos;

	i = (joyfunc) (&keys);			 	// leemos desde teclado

	// sp_PrintAt (1, 1, , );

	xx=mun.dx >> 3;
	yy=mun.dy >> 3;

	if (((i & sp_RIGHT )== 0)) {
		nosmovemos = 0;
		mun.direccion = 0;
		if ((mun.dx & 7) == 0) {
			if ((mun.dy & 7) == 0) {	// el my_attr era antes 48
				if ((my_attr(xx+2,yy)<6) && (my_attr(xx+2,yy+1)<6))
					nosmovemos = 1;
			} else {
				if ((my_attr(xx+2,yy)<6) && (my_attr(xx+2,yy+1)<6) && (my_attr(xx+2,yy+2)<6))
					nosmovemos = 1;
			}
		} else
			nosmovemos = 1;

		if (nosmovemos) {
			mun.dx++;
			if (mun.facing == 1)
				mun.facing = 0;
			else if (mun.facing == 0)
				mun.facing = 1 ;
			else
				mun.facing = 0;
		}
	} else if (((i & sp_LEFT )== 0)) {
		mun.direccion = 1;
		nosmovemos = 0;
		if ((mun.dx & 7) == 0) {
			if ((mun.dy & 7) == 0) {
				if ((my_attr(xx-1,yy)<6) && (my_attr(xx-1,yy+1)<6))
					nosmovemos = 1;
			} else {
				if ((my_attr(xx-1,yy)<6) && (my_attr(xx-1,yy+1)<6) && (my_attr(xx-1,yy+2)<6))
					nosmovemos = 1;
			}
		} else
			nosmovemos = 1;

		if (nosmovemos) {
			mun.dx--;
			if (mun.facing == 2)
				mun.facing = 3;
			else if (mun.facing == 3)
				mun.facing = 2 ;
			else
				mun.facing = 2;
		}
	}

	// Llegados a este punto, 'x' puede haber cambiado,
	// as que hay que recalcular xx:
	xx=mun.dx >> 3;

	if (((i & sp_DOWN )== 0)) {
		nosmovemos = 0;
		if ( (mun.dy & 7) == 0 ) {
			if ( (mun.dx & 7) == 0 ) {
				if ((my_attr(xx,yy+2)<6) && (my_attr(xx+1,yy+2)<6))
					nosmovemos = 1;
			} else {
				if ((my_attr(xx,yy+2)<6) && (my_attr(xx+1,yy+2)<6) && (my_attr(xx+2,yy+2)<6))
					nosmovemos = 1;
			}
		} else
			nosmovemos = 1;

		if (nosmovemos) {
			mun.dy++;
			if (mun.facing == 2)
				mun.facing = 3;
			else if (mun.facing == 3)
				mun.facing = 2 ;


			else if (mun.facing == 1)
				mun.facing = 0;
			else if (mun.facing == 0)
				mun.facing = 1 ;
		}
	}

	// Llegados a este punto, 'y' puede haber cambiado,
	// as que hay que recalcular yy:
	yy=mun.dy >> 3;

	if (((i & sp_DOWN) != 0)) { // efecto de flotar del mueco
		nosmovemos = 0;
		if ( (mun.dy & 7) == 0 ) {
			if ( (mun.dx & 7) == 0 ) {
				if ((my_attr(xx,yy-1)<6) && (my_attr(xx+1,yy-1)<6)) {
					nosmovemos = 1;
				}
			} else {
				if ((my_attr(xx,yy-1)<6) && (my_attr(xx+1,yy-1)<6) && (my_attr(xx+2,yy-1)<6)) {
					nosmovemos = 1;
				}
			}
		} else
			nosmovemos = 1;

		if (nosmovemos) {
			mun.dy--;
		}
	}
	
	// aqui hacemos que mueva tb las patas
	contador_patas++;
	if (mun.facing == 0 && contador_patas == 5) {
		mun.facing = 1 ;
		contador_patas = 0;
	} else if (mun.facing == 1 && contador_patas == 5) {
		mun.facing = 0;
		contador_patas = 0;
	} else if (mun.facing == 2 && contador_patas == 5) {
		mun.facing =3 ;
		contador_patas = 0;
	} else if (mun.facing == 3 && contador_patas == 5) {
		mun.facing =2;
		contador_patas = 0;
	}
	// cambiamos el grafico segun la direccion que vaya

	if (((i & sp_FIRE) == 0) && bandera_disparo==0 && numero_arpones>0) {
		wyz_play_sound (2, CANAL_FX);
		bandera_disparo = 1;
		disparar();
		numero_arpones--;
		pinta_arpones(numero_arpones);
	}

	mueve_disparo();

	// probamos la modificacion
	if (mun.facing == 0)
		mun.next_frame = buzo_r_a_1;
	if (mun.facing == 1)
		mun.next_frame = buzo_r_b_1;
	if (mun.facing == 2)
		mun.next_frame = buzo_l_a_1;
	if (mun.facing == 3)
		mun.next_frame = buzo_l_b_1;

	// pintamos el mueco
	if ((my_attr(xx,yy)==3 || my_attr(xx+1,yy)==3 || my_attr(xx,yy+1)==3 || my_attr(xx+1,yy+1)==3)) {	//debemos ver si hay que poner mas condicionales

		// ahora, hay qeu borrar el grafico, lo buscamos
		for (i = 0; i < N_OBJETOS ; i++) {
			if (numero_pantalla == objetos[i].pantalla && ((objetos[i].tipo == 1) || (objetos[i].tipo == 2) || (objetos[i].tipo == 3) || (objetos[i].tipo == 4))) {  //es la pantalla donde estamos
				if (objetos[i].status == 0) {
					pinta_supertile(objetos[i].x,objetos[i].y,objetos[i].fondo);
					if (numero_pantalla == 28) { 	// pintamos la mascara
						objeto_mascara = 1;
						pinta_objetos(1,4,15);
						objeto_soltado = 1;
						numero_arpones = numero_arpones+2;
						// mascara_cogido();
						pinta_led (2);
						wyz_play_sound (3, CANAL_FX);
					}
					if (numero_pantalla == 31) {	// pintamos diamante
						objeto_diamante = 1;
						pinta_objetos(1,8,14);
						objeto_soltado = 2;
						numero_arpones = numero_arpones+2;
						// diamante_cogido();
						pinta_led (3);
						wyz_play_sound (3, CANAL_FX);
					}
					if (numero_pantalla == 6) {
						objeto_pergamino = 1;
						pinta_objetos(1,12,16); 	// pintamos pergamino
						objeto_soltado = 3;
						numero_arpones = numero_arpones+2;
						// pergamino_cogido();
						pinta_led (1);
						wyz_play_sound (3, CANAL_FX);
					}
					if (numero_pantalla == 17) { 	// pintamos la flor
						pinta_objetos(1,16,17);
						objeto_soltado = 4;
						objeto_flor = 1;
						numero_arpones = numero_arpones+2;
						// flor_cogido();
						pinta_led (4);
						wyz_play_sound (3, CANAL_FX);
					}
				}
				pinta_arpones(numero_arpones);
				objetos[i].status = 1;				// objeto recogido!
				objeto_cogido = 1;
			}

		}
	}

	// si recoge oxigeno de bote
	if (my_attr(xx,yy)==1 || my_attr(xx+1,yy)==1 || my_attr(xx,yy+1)==1 || my_attr(xx+1,yy+1)==1) {   //debemos ver si hay que poner mas condicionales

		// ahora hay que borrar el grafico, lo buscamos
		for (i = 0; i < N_OBJETOS ; i++) {
			if (numero_pantalla == objetos[i].pantalla && objetos[i].tipo == 13) {	//es la pantalla donde estamos
				if (objetos[i].status == 0) {
					pinta_supertile(objetos[i].x,objetos[i].y,objetos[i].fondo);
					mun.botellas++;
					pinta_objetos (12, 20, 5);
					pinta_objetos (12, 22, 6);
					cambia_cara = 0;
					// oxigeno_cogido();
					pinta_led (5);
					wyz_play_sound (5, CANAL_FX);
					/*
					if (mun.botellas == 1) {   //pintamos las botellas
						sp_PrintAtInv (21, 11, 112, 61);
					}
					if (mun.botellas == 2) {
						sp_PrintAtInv (21, 11, 112, 62);
					}
					if (mun.botellas == 3) {
						sp_PrintAtInv (21, 11, 112, 63);
					}
					if (mun.botellas == 4) {
						sp_PrintAtInv (21, 11, 112, 64);
					}
					if (mun.botellas == 5) {
						sp_PrintAtInv (21, 11, 112, 65);
					}*/
					if (mun.botellas)
						sp_PrintAtInv (21, 11, 112, 60 + mun.botellas);
				}
				objetos[i].status = 1;	 //objeto recogido!

			}

		}
	}

	if (my_attr(xx,yy-1)==7 || my_attr(xx+1,yy-1)==7 || my_attr(xx,yy-1)==7 || my_attr(xx+1,yy-1)==7 ) {  //recojemos aire de la superficie
		if (numero_pantalla < 7) {
			if (mun.oxigeno != 100)
				wyz_play_sound (8, CANAL_FX);
			mun.oxigeno = 100;
		}

	} else {
		if (contador_vida == 80) {
			contador_vida = 0;
			mun.oxigeno--;
		}
	}

	if (my_attr(xx,yy)==4 || my_attr(xx+1,yy)==4 || my_attr(xx,yy+1)==4 || my_attr(xx+1,yy+1)==4) {   //debemos ver si hay que poner mas condicionales
		contador_vida++;
		if (contador_vida >= 5) {
			contador_vida = 0;
			mun.oxigeno--;
			wyz_play_sound (1, CANAL_FX);
		}
	}

	//comprobamos las palanca 1
	if (numero_pantalla == 31) {
		if (my_attr(xx,yy) == 2) {
			pinta_supertile(25,14,17);  //pintamos el interruptor activado
			pantalla[3716] = 17;
			animacion_1();
			// compuerta_abierta();
			wyz_play_sound (7, CANAL_FX);
			pinta_led (6);
		}
	}

	if (numero_pantalla == 34) {
		if (my_attr(xx,yy) == 2) {
			pinta_supertile(25,4,17);
			pantalla[4002] = 17;
			animacion_2();
			// compuerta_abierta();
			wyz_play_sound (7, CANAL_FX);
			pinta_led (6);
		}
	}
	if (numero_pantalla == 13) {

		if (my_attr(xx,yy) == 2) {
			pinta_supertile(23,16,17);
			pantalla[1622] = 17;
			pinta_pantalla();
			sp_UpdateNow();
			animacion_3();
			// compuerta_abierta();
			wyz_play_sound (7, CANAL_FX);
			pinta_led (6);
		}
	}
	
	if (mun.oxigeno == 100) {
		pinta_objetos (12, 20, 5);
		pinta_objetos (12, 22, 6);
		cambia_cara = 0;
	}
	if (mun.oxigeno == 75 && mun.botellas==0) {
		pinta_objetos (12, 20, 7);
		pinta_objetos (12, 22, 8);
		cambia_cara = 1;
		wyz_play_sound (8, CANAL_FX);
	}
	if (mun.oxigeno == 50 && mun.botellas==0) {
		pinta_objetos (12, 20, 9);
		pinta_objetos (12, 22, 10);
		cambia_cara = 1;
		wyz_play_sound (8, CANAL_FX);
	}
	if (mun.oxigeno == 25 && mun.botellas==0) {
		pinta_objetos (12, 20, 11);
		pinta_objetos (12, 22, 12);
		cambia_cara = 1;
		limpia_led();
		// peligro();
		pinta_led (7);
		wyz_play_sound (7, CANAL_FX);
	}
	if (mun.oxigeno>75 && cambia_cara==1) {
		pinta_objetos (12, 20, 5);
		pinta_objetos (12, 22, 6);
		cambia_cara = 0;
		wyz_play_sound (7, CANAL_FX);
	}
	if (pinta == 1) {
		puede_pintar++;
		pinta = 0;
	}
	if (puede_pintar == 5000) {
		puede_pintar = 0;
		pinta = 1;
	}

	contador_vida++;
	
	draw_vida();
}

void suelta_objeto() {
	unsigned char xx, yy;

	xx=mun.dx >> 3;
	yy=mun.dy >> 3;
	if (my_attr(xx,yy-2)==69 || my_attr(xx+1,yy-2)==69) {
		if (objeto_cogido == 1 && numero_pantalla == 2) {
			// Debemos soltar el objeto
			objeto_cogido = 0;
			numero_arpones = numero_arpones+5;
			pinta_arpones(numero_arpones);
			//men_cogido();
			pinta_led (0);
			
			if (objeto_mascara == 1) { 
				// pintamos la mascara
				objeto_mascara = 2;
				pinta_objetos(1,4,19);
				if (numero_arpones > 9) {
					numero_arpones = 9;
				}
				objeto_cargado++;
			}
			if (objeto_diamante == 1) { 
				// pintamos diamante 2
				objeto_diamante = 2;
				pinta_objetos(1,8,18);
				sp_PrintAtInv (22, 11, 112, 61);
				objeto_cargado++;
			}
			if (objeto_pergamino == 1) {
				// pintamos pergamino 3
				pinta_objetos(1,12,20);  
				objeto_pergamino = 2;
				sp_PrintAtInv (22, 11, 112, 61);
				objeto_cargado++;
			}
			if (objeto_flor == 1) { 
				// pintamos la flor 4
				objeto_flor = 2;
				pinta_objetos(1,16,21);
				sp_PrintAtInv (22, 11, 112, 61);
				objeto_cargado++;
			}
		}
	}
}

void comprueba_oxigeno() {
	unsigned char j;
	if (mun.oxigeno <= 0) {
		if (mun.botellas > 0) {
			mun.oxigeno = 100;
			mun.botellas--;
			//tenemos que repintar las botellas
			
			/*
			if (mun.botellas == 1) {   //pintamos las botellas
				j = 61;

			}
			if (mun.botellas == 2) {
				j = 62;

			}
			if (mun.botellas == 3) {
				j = 63;

			}
			if (mun.botellas == 4) {
				j = 64;

			}
			if (mun.botellas == 5) {
				j = 65;

			}
			if (mun.botellas == 0) {
				j = 60;

			}*/
			
			j = 60 + mun.botellas;
	
			sp_PrintAtInv (21, 11, 112, j);
		}
	}

}

void reincia_mapa() {
	// Restauramos las palancas:
	
	pantalla[3716] = 16;			// Palanca 1
	pantalla[4002] = 16;			// Palanca 2
	pantalla[1622] = 16;			// Palanca 3
	
	// Restauramos las compuertas:
	
	pantalla[2970] = 10;			// Compuerta accionada por la palanca 1
	pantalla[2983] = 10;
	pantalla[2996] = 10;
	pantalla[3009] = 10;
	pantalla[3022] = 10;
	
	pantalla[3071] = 10;			// Compuerta accionada por la palanca 2
	pantalla[3072] = 10;
	pantalla[3073] = 10;
	pantalla[3074] = 10;
	pantalla[3075] = 10;
	pantalla[3076] = 10;
	pantalla[3077] = 10;
	
	pantalla[1578] = 10;			// Compuerta accionada por la palanca 3
}

unsigned char bandera_pez = 0;	//0 primer tile, 1 segundo tile
unsigned char bandera_medusa = 0;  //controla el frame siguiente
unsigned char bandera_pulpo = 0;
unsigned char contador_medusa = 0;

unsigned char tocado = 0; //esta variable inmovilizara al enemigo durante 300 iteraciones
unsigned char parado = 0;
unsigned char esJugador = 0;

//rutina de movimiento de enemigos
void mueve_enemigos() {
	unsigned char i;
	unsigned int pos;
	unsigned char xx,yy, nosmovemos;
	unsigned int datoRandom;

	for (i = 0; i < 2 ; i++) {

		//sacamos la posicion de la tabla que las almacena
		pos = tabla_posiciones[i];
		xx=enemigos[pos].x >> 3;
		yy=enemigos[pos].y >> 3;

		//movemos los enemigos
		
		if (pos != -1) {
			if (((mun.dx+3 <= enemigos[pos].x+3) && (mun.dx+13>=enemigos[pos].x+3)) || ((mun.dx+3<=enemigos[pos].x+13) && (mun.dx+13>=enemigos[pos].x+13))) {
				if (((mun.dy+3<=enemigos[pos].y +3) && (mun.dy+13>=enemigos[pos].y+3)) || ((mun.dy+3<=enemigos[pos].y+13)&&(mun.dy+13>=enemigos[pos].y+13))) {
					if (!enemigos[pos].tocado) {
						mun.oxigeno--;
						wyz_play_sound (1, CANAL_FX);
						esJugador=1;
					}
				}
			} else {
				esJugador = 0;
			}
			//colisones con arpones
			if ((posicion_disparo_x + 3 <= enemigos[pos].x + 13) && (posicion_disparo_x + 3 >= enemigos[pos].x + 3)) {
				if ((posicion_disparo_y + 3 <= enemigos[pos].y + 13) && (enemigos[pos].y  <=posicion_disparo_y+ 3)) {
					esJugador =0;
					enemigos[pos].tocado = 1;
					sp_MoveSprAbs(spriteArpon, sp_ClipStruct, 0, -10, -10, -10, -10);
					direccion_disparo = 0;
					bandera_disparo = 0;

					borra_disp = 1;
					cambia_pantalla = 0;
					posicion_disparo_x = -1;
					posicion_disparo_y = -1;
					disparado = 0;
					wyz_play_sound (7, CANAL_FX);
				}
			} else {
				esJugador = 1;
			}

			if (enemigos[pos].tocado == 1) {
				enemigos[pos].contador++;
				if (enemigos[pos].contador == 100) {
					enemigos[pos].tocado = 0;
					enemigos[pos].contador = 0;
				}
			}

			if (enemigos[pos].tipo == 1 && enemigos[pos].tocado == 0) {   //es un pez, se mueve de lado

				//vamos a la izquierda
				if (enemigos[pos].movimiento == 1 ) {
					nosmovemos = 0;
					if ((enemigos[pos].x & 7) == 0) {
						if ((enemigos[pos].y & 7) == 0) {
							if ((my_attr(xx-1,yy)<6) && (my_attr(xx-1,yy+1)<6))
								nosmovemos = 1;
						} else {
							if ((my_attr(xx-1,yy)<6) && (my_attr(xx-1,yy+1)<6) && (my_attr(xx-1,yy+2)<6))
								nosmovemos = 1;
						}
					} else
						nosmovemos = 1;

					if (enemigos[pos].x == 24) {
						nosmovemos = 0;
					}
					if (nosmovemos) {
						enemigos[pos].x--;
						//cambio de grafico

						if (enemigos[pos].x % 5 == 0) {
							if (tabla_frames[0].facing == 1) {
								if (bandera_pez == 0) {
									tabla_frames[0].facing = 2;
									bandera_pez = 1;
								} else {
									tabla_frames[0].facing = 3;
									bandera_pez = 0;
								}
							} else {
								tabla_frames[0].facing = 1;
							}
						}
					} else {
						enemigos[pos].movimiento = 2;	//va a la derecha
						tabla_frames[0].facing = 4; //cambio de sentido

					}
				}
				//vamos a la derecha
				else if (enemigos[pos].movimiento == 2 ) {

					nosmovemos = 0;
					if ((enemigos[pos].x & 7) == 7) {
						if ((enemigos[pos].y & 7) == 0) {
							if ((my_attr(xx+3,yy)<6) && (my_attr(xx+3,yy+1)<6))
								nosmovemos = 1;
						} else {
							if ((my_attr(xx+3,yy)<6) && (my_attr(xx+3,yy+1)<6) && (my_attr(xx+3,yy+2)<6))
								nosmovemos = 1;
						}
					} else
						nosmovemos = 1;

					if (nosmovemos) {
						enemigos[pos].x++;
						if (enemigos[pos].x % 5 == 0 ) {
							if (tabla_frames[0].facing == 5) {
								if (bandera_pez == 0) {
									tabla_frames[0].facing = 6;
									bandera_pez = 1;
								} else {
									tabla_frames[0].facing = 7;
									bandera_pez = 0;
								}
							} else {
								tabla_frames[0].facing = 5;
							}
						}
					} else {
						enemigos[pos].movimiento = 1;
						tabla_frames[0].facing = 4;

					}
				}
			}  // ahora, ver si es pulpo o medusa
			else if (enemigos[pos].tipo == 2 && enemigos[pos].tocado == 0) {   //es un pulpo, se mueve de arriba a abajo

				//vamos arriba
				if (enemigos[pos].movimiento == 1) {
					nosmovemos = 0;
					if ( (enemigos[pos].y & 7) == 0 ) {
						if ( (enemigos[pos].x & 7) == 0 ) {
							if ((my_attr(xx,yy-1)<6) && (my_attr(xx+1,yy-1)<6))
								nosmovemos = 1;
						} else {
							if ((my_attr(xx,yy-1)<6) && (my_attr(xx+1,yy-1)<6) && (my_attr(xx+2,yy-1)<6))
								nosmovemos = 1;
						}
					} else
						nosmovemos = 1;

					if (nosmovemos) {
						enemigos[pos].y--;
						if (enemigos[pos].y % 5 == 0) {
							if (tabla_frames[1].facing == 1) {
								if (bandera_pulpo == 0) {
									tabla_frames[1].facing = 2;
									bandera_pulpo = 1;
								} else {
									tabla_frames[1].facing = 3;
									bandera_pulpo = 0;
								}
							} else {
								tabla_frames[1].facing = 1;
							}
						}
					} else {
						enemigos[pos].movimiento = 2;	//va a la derecha
					}

				}
				//vamos abajo
				else if (enemigos[pos].movimiento == 2) {

					nosmovemos = 0;
					if ( (enemigos[pos].y & 7) == 0 ) {
						if ( (enemigos[pos].x & 7) == 0 ) {
							if ((my_attr(xx,yy+2)<6) && (my_attr(xx+1,yy+2)<6))
								nosmovemos = 1;
						} else {
							if ((my_attr(xx,yy+2)<6) && (my_attr(xx+1,yy+2)<6) && (my_attr(xx+2,yy+2)<6))
								nosmovemos = 1;
						}
					} else
						nosmovemos = 1;

					if (nosmovemos) {
						enemigos[pos].y++;
						if (enemigos[pos].y % 5 ==0) {
							if (tabla_frames[1].facing == 1) {
								if (bandera_pulpo == 0) {
									tabla_frames[1].facing = 2;
									bandera_pulpo = 1;
								} else {
									tabla_frames[1].facing = 3;
									bandera_pulpo = 0;
								}
							} else {
								tabla_frames[1].facing = 1;
							}
						}
					} else {
						enemigos[pos].movimiento = 1;

					}
				}

			}
		}

		if (enemigos[pos].tipo == 3 && enemigos[pos].tocado == 0) {

			datoRandom = rand()%4;
			contador_medusa++;
			if (enemigos[pos].y >= 140)
				datoRandom = 0;

			if (datoRandom == 0) { //arriba
				nosmovemos = 0;
				if ( (enemigos[pos].y & 7) == 0 ) {
					if ( (enemigos[pos].x & 7) == 0 ) {
						if ((my_attr(xx,yy-1)<6) && (my_attr(xx+1,yy-1)<6))
							nosmovemos = 1;
					} else {
						if ((my_attr(xx,yy-1)<6) && (my_attr(xx+1,yy-1)<6) && (my_attr(xx+2,yy-1)<6))
							nosmovemos = 1;
					}
				} else
					nosmovemos = 1;


				if (nosmovemos) {
					enemigos[pos].y--;
					if (contador_medusa == 5) {
						contador_medusa = 0;
						if (tabla_frames[2].facing == 1) {
							if (bandera_medusa == 0) {
								tabla_frames[2].facing = 2;
								bandera_medusa = 1;
							} else {
								tabla_frames[2].facing = 3;
								bandera_medusa = 0;
							}
						} else {
							tabla_frames[2].facing = 1;
						}
					}
				}
			} else if (datoRandom == 1) {  //abajo
				nosmovemos = 0;
				if ( (enemigos[pos].y & 7) == 0 ) {
					if ( (enemigos[pos].x & 7) == 0 ) {
						if ((my_attr(xx,yy+2)<6) && (my_attr(xx+1,yy+2)<6))
							nosmovemos = 1;
					} else {
						if ((my_attr(xx,yy+2)<6) && (my_attr(xx+1,yy+2)<6) && (my_attr(xx+2,yy+2)<6))
							nosmovemos = 1;
					}
				} else
					nosmovemos = 1;

				if (nosmovemos) {
					enemigos[pos].y++;
					if (contador_medusa == 5) {
						contador_medusa = 0;
						if (tabla_frames[2].facing == 1) {
							if (bandera_medusa == 0) {
								tabla_frames[2].facing = 2;
								bandera_medusa = 1;
							} else {
								tabla_frames[2].facing = 3;
								bandera_medusa = 0;
							}
						} else {
							tabla_frames[2].facing = 1;
						}
					}
				}
			} else if (datoRandom == 2) {
				nosmovemos = 0;
				if ((enemigos[pos].x & 7) == 0) {
					if ((enemigos[pos].y & 7) == 0) {
						if ((my_attr(xx-1,yy)<6) && (my_attr(xx-1,yy+1)<6))
							nosmovemos = 1;
					} else {
						if ((my_attr(xx-1,yy)<6) && (my_attr(xx-1,yy+1)<6) && (my_attr(xx-1,yy+2)<6))
							nosmovemos = 1;
					}
				} else
					nosmovemos = 1;

				if (nosmovemos) {
					enemigos[pos].x--;
					if (contador_medusa == 5) {
						contador_medusa = 0;
						if (tabla_frames[2].facing == 2) {
							if (bandera_medusa == 0) {
								tabla_frames[2].facing = 1;
								bandera_medusa = 1;
							} else {
								tabla_frames[2].facing = 3;
								bandera_medusa = 0;
							}
						} else {
							tabla_frames[2].facing = 2;
						}
					}
				}
			}  //izquierda
			else if (datoRandom == 3) { //derecha
				nosmovemos = 0;
				if ((enemigos[pos].x & 7) == 7) {
					if ((enemigos[pos].y & 7) == 0) {
						if ((my_attr(xx+3,yy)<6) && (my_attr(xx+3,yy+1)<6))
							nosmovemos = 1;
					} else {
						if ((my_attr(xx+3,yy)<6) && (my_attr(xx+3,yy+1)<6) && (my_attr(xx+3,yy+2)<6))
							nosmovemos = 1;
					}
				} else
					nosmovemos = 1;

				if (nosmovemos) {
					enemigos[pos].x++;
					if (contador_medusa == 5) {
						contador_medusa = 0;
						if (tabla_frames[2].facing == 2) {
							if (bandera_medusa == 0) {
								tabla_frames[2].facing = 1;
								bandera_medusa = 1;
							} else {
								tabla_frames[2].facing = 3;
								bandera_medusa = 0;
							}
						} else {
							tabla_frames[2].facing = 2;
						}
					}
				}
			}
		}

	}
	//recorremos los dos elementos
	for (i = 0; i < 2; i++) {
		pos = tabla_posiciones[i];
		if (pos != -1) {
			if (enemigos[pos].tipo == 1) { 
				// movimiento y cambio de frames del pez
				// probamos la modificacion
				
				/*
				if (tabla_frames[0].facing == 1)
					tabla_frames[0].next_frame = pez_l_a_1;
				if (tabla_frames[0].facing == 2)
					tabla_frames[0].next_frame = pez_l_a_1 + 144;
				if (tabla_frames[0].facing == 3)
					tabla_frames[0].next_frame = pez_l_a_1 + 288;
				if (tabla_frames[0].facing == 4) {
					tabla_frames[0].next_frame = pez_l_a_1 + 432;
				}
				if (tabla_frames[0].facing == 5)
					tabla_frames[0].next_frame = pez_l_a_1 + 576;
				if (tabla_frames[0].facing == 6)
					tabla_frames[0].next_frame = pez_l_a_1 + 720;
				if (tabla_frames[0].facing == 7)
					tabla_frames[0].next_frame = pez_l_a_1 + 864;
				*/
				
				tabla_frames [0].next_frame = pez_l_a_1 + 144 * (tabla_frames [0].facing - 1);
				
				sp_MoveSprAbs(spritesEne[0], sp_ClipStruct,tabla_frames[0].next_frame-tabla_frames[0].current_frame,enemigos[pos].y >> 3, enemigos[pos].x >> 3, enemigos[pos].x & 7, enemigos[pos].y &7);

				tabla_frames[0].current_frame = tabla_frames[0].next_frame;
			}
			if (enemigos[pos].tipo == 2) {
				//movimiento y cambio de frames del pulpo
				
				/*	
				if (tabla_frames[1].facing == 1)
					tabla_frames[1].next_frame = pulpo_a_1;
				if (tabla_frames[1].facing == 2)
					tabla_frames[1].next_frame = pulpo_a_1 + 144 ;
				if (tabla_frames[1].facing == 3)
					tabla_frames[1].next_frame = pulpo_a_1 + 288 ;
				*/
				
				tabla_frames[1].next_frame = pulpo_a_1 + 144 * (tabla_frames[1].facing - 1);
				
				sp_MoveSprAbs(spritesEne[1], sp_ClipStruct,tabla_frames[1].next_frame-tabla_frames[1].current_frame, enemigos[pos].y >> 3, enemigos[pos].x >> 3, enemigos[pos].x & 7, enemigos[pos].y &7);
				tabla_frames[1].current_frame = tabla_frames[1].next_frame;
			}
			if (enemigos[pos].tipo == 3) {
				//movimiento y cambio de frame de la	medusa
				
				/*
				if (tabla_frames[2].facing == 1)
					tabla_frames[2].next_frame = medusa_a_1;
				if (tabla_frames[2].facing == 2)
					tabla_frames[2].next_frame = medusa_b_1  ;
				if (tabla_frames[2].facing == 3)
					tabla_frames[2].next_frame = medusa_c_1 ;
				*/
				
				tabla_frames[2].next_frame = medusa_a_1 + 144 * (tabla_frames[2].facing - 1);
				
				sp_MoveSprAbs(spritesEne[2], sp_ClipStruct,tabla_frames[2].next_frame-tabla_frames[2].current_frame, enemigos[pos].y >> 3, enemigos[pos].x >> 3, enemigos[pos].x & 7, enemigos[pos].y &7);
				tabla_frames[2].current_frame = tabla_frames[2].next_frame;
			}
		}

	}
}

void cambio_de_pantalla() {
	limpia_led();
	//sp_MoveSprAbs(spriteBuzo, sp_ClipStruct, mun.next_frame - mun.current_frame, -10, -10, -10, -10);
	elimina_enemigos_pantalla();
	if (bandera_disparo==1) cambia_pantalla = 1;
	sp_MoveSprAbs(spriteArpon, sp_ClipStruct, 0, -2, -2, -2, -2);
	pinta_pantalla();
	carga_enemigos();
}

unsigned char selecciona_lenguaje () {
	
	// jL :: Esto se usa para establecer la variable lenguaje
	// que vale 0 para ingls, y 1 para apa.
	
	unsigned char res = 2;
	unsigned int key_1, key_2;
	
	key_1 = sp_LookupKey ('1');
	key_2 = sp_LookupKey ('2');
	
	unpack_RAM3 (50763);
	
	while (res == 2) {
		if (sp_KeyPressed (key_2))
			res = 0;
		if (sp_KeyPressed (key_1))
			res = 1;
	}
	
	cortina ();
	
	return res; 
}

char espera_activa (int espera) {
	
	// jL
	
	// Esta funcin espera un rato o hasta que se pulse una tecla.
	// Si se pulsa una tecla, devuelve 0
	
	// Esta funcin slo funciona en Spectrum.
	// en CPC no hay una interrupcin cada 20ms, asn que esto no
	// sirve "pa n".
	
	char res = 1;
	int i;
	
	for (i = 0; i < espera && res; i ++) {
		#asm
			halt
		#endasm
		if (sp_GetKey ()) 
			res = 0;
	}
	
	return res;
}

void intro () {
	
	// jL :: Logos y poco ms, esto es lo que sale nada ms
	// seleccionar idioma... Autobombo y tentetieso.
	
	unpack_RAM3 (49152);
	wyz_play_sound (7, CANAL_FX);
	espera_activa (200);
	cortina ();
	unpack_RAM3 (49468);
	wyz_play_sound (7, CANAL_FX);
	espera_activa (200);
	cortina ();
	unpack_RAM3 (51728);
	wyz_play_sound (7, CANAL_FX);
	espera_activa (500);
	cortina ();
}

void selecciona_control () {
	unsigned int key_k, key_j;
	unsigned char terminado = 0;
	
	key_k = sp_LookupKey ('k');
	key_j = sp_LookupKey ('j');
	
	while (!terminado) {
		if (sp_KeyPressed (key_j)) {
			terminado = 1;
			joyfunc = sp_JoyKempston;
		} else if (sp_KeyPressed (key_k)) {
			terminado = 1;
			joyfunc = sp_JoyKeyboard;
		}
	}
}

main() {
	char x, y, j, i;
	unsigned char ke;
	char firsttime = 1;

	unsigned int teclaStart;
	int xx,yy;
	unsigned char *allpurposepuntero;
	unsigned char cont;
	unsigned int reset;
	unsigned char fin;
	
	// Sustituye ISR por defecto por la funcin ISR y activa IM2.
	
	#asm
		di
	#endasm

	sp_InitIM2(0xf1f1);
	sp_CreateGenericISR(0xf1f1);
	sp_RegisterHook(255, ISR);

	#asm
		ei
	#endasm
	
	// Definir rea de clipping para los sprites
	
	// Definir teclas:
	
	keys.down  = sp_LookupKey('a');
	keys.left  = sp_LookupKey('o');
	keys.right = sp_LookupKey('p');
	keys.fire  = sp_LookupKey(' ');
	teclaStart = sp_LookupKey('0');
	
	srand (100);
	
	mun.frame = 0;
	mun.subframe = 0;	//pongamos q 0 es el 1er sprite y 1 el segundo
	mun.facing = 1;
	mun.oxigeno = 100;
	mun.botellas = 0;
	mun.direccion = 0;
	mun.dx = 40;
	mun.dy = 30;
	
	allpurposepuntero = map_tiles;
	for (cont = 0; cont < 208; cont++) {
		sp_TileArray (cont, allpurposepuntero);
		allpurposepuntero += 8;
	}
	sp_TileArray (200, disparo);

	sp_Initialize(INK_CYAN | PAPER_BLACK, 0);
	sp_Border(BLACK);
	sp_AddMemory(0, 50, 14, 59948);
	j=0;

	//inicializamos sprites personajes

	spriteBuzo = sp_CreateSpr(sp_MASK_SPRITE, 3,  buzo_r_a_1, 1, TRANSPARENT);
	sp_AddColSpr(spriteBuzo, buzo_r_a_2, TRANSPARENT);
	sp_AddColSpr(spriteBuzo, buzo_r_a_3, TRANSPARENT);

	spritesEne[0] = sp_CreateSpr(sp_MASK_SPRITE, 3,pez_l_a_1 , 1, TRANSPARENT);
	sp_AddColSpr(spritesEne[0], pez_l_a_2, TRANSPARENT);
	sp_AddColSpr(spritesEne[0], pez_l_a_3, TRANSPARENT);

	//hay q poner al pulpo
	spritesEne[1] = sp_CreateSpr(sp_MASK_SPRITE, 3, pulpo_a_1 + 144  , 1, TRANSPARENT);
	sp_AddColSpr(spritesEne[1], pulpo_a_2 + 144, TRANSPARENT);
	sp_AddColSpr(spritesEne[1], pulpo_a_3  + 144, TRANSPARENT);

	spritesEne[2] = sp_CreateSpr(sp_MASK_SPRITE, 3, medusa_a_1, 1, TRANSPARENT);
	sp_AddColSpr(spritesEne[2], medusa_a_2, TRANSPARENT);
	sp_AddColSpr(spritesEne[2], medusa_a_3, TRANSPARENT);

	spriteArpon = sp_CreateSpr(sp_MASK_SPRITE, 3, disparo_d, 1, TRANSPARENT);
	sp_AddColSpr(spriteArpon, medusa_a_3, TRANSPARENT);
	sp_AddColSpr(spriteArpon, medusa_a_3, TRANSPARENT);

	mun.current_frame = mun.next_frame = buzo_r_a_1;
	tabla_frames[0].current_frame = tabla_frames[0].next_frame = pez_l_a_1;
	tabla_frames[0].facing = 1;
	tabla_frames[1].current_frame = tabla_frames[1].next_frame = pulpo_a_1 + 144 ;
	tabla_frames[1].facing = 2;
	tabla_frames[2].current_frame = tabla_frames[2].next_frame = medusa_a_1;
	tabla_frames[2].facing = 1;

	// jL :: Lo primero es seleccionar el lenguaje
	
	lenguaje = selecciona_lenguaje ();
	
	// Ya.

	// Ajusto sp_ClipStruct porque no me gusta como est que borra el marco el mamom.
	sp_ClipStruct->row_coord = 2;
	sp_ClipStruct->col_coord = 3;
	sp_ClipStruct->width = 26;
	sp_ClipStruct->height = 18;
		
	while (1 == 1) {
		
		// borramos el mueco de pantalla
		elimina_enemigos_pantalla();
		sp_MoveSprAbs(spriteBuzo, sp_ClipStruct, 0, -2, -2, -2, -2);

		mun.oxigeno = 100;
		mun.botellas = 0;

		mun.dx=40;
		mun.dy=38;
		numero_pantalla = 2;
		numero_arpones = 5;

		bandera_pez = 0;		// 0 primer tile, 1 segundo tile
		bandera_medusa = 0; 	// controla el frame siguiente
		bandera_pulpo = 0;
		contador_medusa = 0;

		tocado = 0; 			// esta variable inmovilizara al enemigo durante 300 iteraciones
		parado = 0;
		esJugador = 0;
		objeto_cargado =0;		// objetos que estan en el barco
		objeto_cogido = 0;
		contador_vida = 0;
		contador_patas = 0;
		interruptores = 0;		// numero de interruptores activados

		disparado = 0;
		posicion_disparo_x;
		posicion_disparo_y;
		direccion_disparo = 0;
		bandera_disparo = 0;

		// Si es la primera vez, ponemos la intro
		
		if (firsttime) {
			firsttime = 0;
			intro ();
		}
		
		// Descomprimimos la pantalla de men, que est en RAM3
		
		unpack_RAM3 (50862);
		
		// Msica del men
		
		wyz_play_music (1);

		// Seleccin de control 
						
		selecciona_control ();
		
		cortina ();
		
		wyz_stop_sound ();
		
		//bucle principal
		
		sp_UpdateNow();

		// Descomprimimos el marcador, que est en RAM3
		
		if (lenguaje == 0)
			unpack_RAM3 (53394);
		else
			unpack_RAM3 (54507);
		
		pinta_pantalla();
		
		//inicializacion del mueco principal

		elimina_enemigos_pantalla();
		sp_MoveSprAbs(spriteBuzo, sp_ClipStruct, 0, mun.dy >> 3, mun.dx >> 3, (mun.dx & 7), (mun.dy & 7));
		draw_vida();
		carga_enemigos();
		pinta_arpones(numero_arpones);
		limpia_led();
		// comienza_aventura();
		pinta_led (8);
		sp_PrintAtInv (21, 11, 112, 60);
		
		// Reinicializamos todos los objetos.
		
		for (i = 0; i < N_OBJETOS ; i++) {
			objetos[i].status = 0;                
		}
		
		wyz_play_music (0);
		
		while (mun.oxigeno>0 && objeto_cargado<4) {
			sp_UpdateNow();

			mueve();
			sp_MoveSprAbs(spriteBuzo, sp_ClipStruct, mun.next_frame - mun.current_frame, mun.dy>>3, mun.dx>>3, mun.dx & 7, mun.dy & 7);
			mun.current_frame = mun.next_frame;
			mueve_enemigos();

			comprueba_oxigeno();

			ke = (joyfunc) (&keys);			 	// leemos desde teclado
			
			/*if (sp_KeyPressed (teclaStart)) {
				numero_pantalla ++;
				cambio_de_pantalla ();	
			}*/
				
			if (mun.dy == 144 && (ke & sp_DOWN) == 0) {		// bajamos un nivel
				numero_pantalla = numero_pantalla + 7;		// el 7 es el ancho del mapa
				mun.dy = 16;
				cambio_de_pantalla();
			}
			if (mun.dy == 16 && numero_pantalla != 0 && !((ke & sp_DOWN) == 0)) { 	// subimos un nivel
				numero_pantalla = numero_pantalla - 7;
				mun.dy = 144;
				cambio_de_pantalla();
			}
			if (mun.dx >= 216 && (ke & sp_RIGHT) == 0) {		// vamos a la derecha
				numero_pantalla ++ ;
				mun.dx = 24;
				cambio_de_pantalla();
			}
			if (mun.dx <= 24 && (ke & sp_LEFT) == 0) { 		// vamos a la izquierda
				numero_pantalla--;
				mun.dx = 216;
				cambio_de_pantalla();
			}
			suelta_objeto();

		}
		
		// game Over
		
		sp_MoveSprAbs(spriteBuzo, sp_ClipStruct, mun.next_frame - mun.current_frame, -10, -10, -10, -10);
		elimina_enemigos_pantalla();
		for (i = 3; i < 27+1; i++) {
			for (fin = 2; fin < 19; fin++) {
				pinta_objetos(i,fin,0);
				sp_UpdateNow();
			}
		}
		
		parada();
		
		if (objeto_cargado == 4) {
			cortina ();
			wyz_stop_sound ();	
			// Descomprimimos el final, que est en RAM3
			if (lenguaje == 0)
				unpack_RAM3 (55624);
			else
				unpack_RAM3 (57355);		
			wyz_play_music (1);
			while (sp_GetKey ());
			while (!sp_GetKey ());
		} else {
			wyz_stop_sound ();
			limpia_led();
			game_over();
			pinta_objetos(14,10,22);
			pinta_objetos(16,10,23);
			sp_UpdateNow();
			wyz_play_music (2);
			espera_activa (220);
		}
		
		objeto_cargado = 0;
		
		cortina ();
		
		//inicializaciones
		numero_pantalla = 2;
		mun.oxigeno = 100;
		reincia_mapa();
		wyz_stop_sound ();	
	}

}
